import { debounce } from "@lincode/utils";
import { useEffect } from "react";
import { Cancellable } from "@lincode/promiselikes";
import useMemoOnce from "./useMemoOnce";
export default (cb, deps, timeout = 0) => {
    const debouncedCb = useMemoOnce(() => debounce(cb, timeout, "trailingPromise"));
    useEffect(() => {
        const handle = new Cancellable();
        debouncedCb().then(cleanup => cleanup && handle.then(cleanup));
        return () => {
            handle.cancel();
        };
    }, deps);
};
